using System;
using System.Windows.Forms;
using Microsoft.Office.Core;
using Microsoft.VisualStudio.Tools.Applications.Runtime;
using Outlook = Microsoft.Office.Interop.Outlook;
using Office = Microsoft.Office.Core;
using Microsoft.Synchronization;

namespace ToodleOutlook
{
    
    public partial class ThisAddIn
    {
        Office.CommandBar newToolBar;
        Office.CommandBarButton firstButton;
        Office.CommandBarButton secondButton;
        Outlook.Explorers selectExplorers;

        private void ThisAddIn_Startup(object sender, System.EventArgs e)
        {

            selectExplorers = this.Application.Explorers;
            selectExplorers.NewExplorer += new Outlook
                .ExplorersEvents_NewExplorerEventHandler(newExplorer_Event);
            AddToolbar();
        }

        private void newExplorer_Event(Outlook.Explorer new_Explorer)
        {
            ((Outlook._Explorer)new_Explorer).Activate();
            newToolBar = null;
            AddToolbar();
        }

        private void AddToolbar()
        {

            if (newToolBar == null)
            {
                Office.CommandBars cmdBars =
                    this.Application.ActiveExplorer().CommandBars;
                newToolBar = cmdBars.Add("ToodleOutlook",
                    Office.MsoBarPosition.msoBarTop, false, true);
            }
            try
            {
                Office.CommandBarButton button_1 =
                    (Office.CommandBarButton)newToolBar.Controls
                    .Add(1, missing, missing, missing, missing);
                button_1.Style = Office
                    .MsoButtonStyle.msoButtonCaption;
                button_1.Caption = "Sync";
                button_1.Tag = "Sync";
                if (this.firstButton == null)
                {
                    this.firstButton = button_1;
                    firstButton.Click += new Office.
                        _CommandBarButtonEvents_ClickEventHandler
                        (SyncClick);
                }

                Office.CommandBarButton button_2 = (Office
                    .CommandBarButton)newToolBar.Controls.Add
                    (1, missing, missing, missing, missing);
                button_2.Style = Office
                    .MsoButtonStyle.msoButtonCaption;
                button_2.Caption = "Settings";
                button_2.Tag = "Settings";
                newToolBar.Visible = true;
                if (this.secondButton == null)
                {
                    this.secondButton = button_2;
                    secondButton.Click += new Office.
                        _CommandBarButtonEvents_ClickEventHandler
                        (SettingsClick);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void SyncClick(Office.CommandBarButton ctrl,
                ref bool cancel)
        {
            ToodleDoProvider td = new ToodleDoProvider();
            //OutlookTaskProvider ot = new OutlookTaskProvider();
            //SyncOrchestrator agent = new SyncOrchestrator();
            //agent.Direction = SyncDirectionOrder.DownloadAndUpload;
            //agent.LocalProvider = ot;
            //agent.RemoteProvider = td;
            //SyncOperationStatistics stats = agent.Synchronize();
            //MessageBox.Show(stats.DownloadChangesApplied.ToString() + " new tasks added to Outlook from ToodleDo" +
              //  stats.UploadChangesApplied.ToString() + " new tasks uploaded to ToodleDo");
            MessageBox.Show(td.generateKey());
        
        }

        private void SettingsClick(Office.CommandBarButton ctrl,
               ref bool cancel)
        {
            MessageBox.Show("You clicked: " + ctrl.Caption);
        }


        #region VSTO generated code

        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InternalStartup()
        {
            this.Startup += new System.EventHandler(ThisAddIn_Startup);
           // this.Shutdown += new System.EventHandler(ThisAddIn_Shutdown);
        }

        #endregion
    }
}
